#!/bin/sh
#. /etc/functions.sh

##### Rule : When wds ap or wds bridge enable/disable set proc vlan_passthrough enable/disable

vlan_pass_proc="/proc/sys/net/8021q/vlan_passthrough"
wds_iface_proc="/proc/sys/net/8021q/wds_ifname"

vlan_passthrough()
{
	local isWdsBridge=$(uci show wireless | grep opmode  | cut -d "=" -f 2 | xargs | grep wds_bridge)
	local isWdsAp=$(uci show wireless | grep opmode  | cut -d "=" -f 2 | xargs | grep wds_ap)
	local isWdsSta=$(uci show wireless | grep opmode  | cut -d "=" -f 2 | xargs | grep wds_sta)
	local mesh_off=$(uci get mesh.wifi.disabled)

	local ethIf=$(uci get /rom/etc/config/network.lan.ifname)
	local batmanIf="bat0"
	local vlanpassIf=""

	# mpsk check
	local mpsk_no_vlan=$(uci -q get functionlist.functionlist.MPSK_NOT_SUPPORT_VLAN)


	if [ "$mesh_off" == "0" ]; then
		vlanpassIf="$batmanIf $ethIf"
		if [ "$mpsk_no_vlan" != "1" ]; then
			mpsk_ifs=$(foreach wireless wifi-iface multi_group_key 1)
			for mpsk_if in $mpsk_ifs; do
				[ "$(uci get wireless.$mpsk_if.disabled)" = "0" ] && vlanpassIf="$vlanpassIf $(uci get wireless.$mpsk_if.ifname)"
			done
		fi
	elif [ -n "$isWdsAp" ]; then
		vlanpassIf="$ethIf"
		wds_vif=$(eval /usr/sbin/foreach wireless wifi-iface mode_display wds_ap)
		for vif in $wds_vif; do
			if [ "$(uci get wireless.$vif.disabled)" == "0" ]; then
				wds_ifname=$(uci get wireless.$vif.ifname)
				[ -n "$wds_ifname" ] && {
					vlanpassIf="$vlanpassIf $wds_ifname"
				}
			fi
		done
	elif [ -n "$isWdsBridge" ]; then
		vlanpassIf="$ethIf"
		wds_vif=$(eval /usr/sbin/foreach wireless wifi-iface mode_display wds_bridge)
		for vif in $wds_vif; do
			if [ "$(uci get wireless.$vif.disabled)" == "0" ]; then
				wds_ifname=$(uci get wireless.$vif.ifname)
				[ -n "$wds_ifname" ] && {
					vlanpassIf="$vlanpassIf $wds_ifname"
				}
			fi
		done
	elif [ -n "$isWdsSta" ]; then
		vlanpassIf="$ethIf"
		wds_vif=$(eval /usr/sbin/foreach wireless wifi-iface mode_display wds_sta)
		for vif in $wds_vif; do
			if [ "$(uci get wireless.$vif.disabled)" == "0" ]; then
				wds_ifname=$(uci get wireless.$vif.ifname)
				[ -n "$wds_ifname" ] && {
					vlanpassIf="$vlanpassIf $wds_ifname"
				}
			fi
		done
	fi

	if [ -n "$vlanpassIf" ]; then
		[ -e "$vlan_pass_proc" ] && echo 1 > $vlan_pass_proc
		# need a " "(space) at last
		[ -e "$wds_iface_proc" ] && echo "$vlanpassIf " > $wds_iface_proc
	else
		[ -e "$vlan_pass_proc" ] && echo 0 > $vlan_pass_proc
		[ -e "$wds_iface_proc" ] && echo '' > $wds_iface_proc
	fi
}
